/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20160108-64
 * Copyright (c) 2000 - 2016 Intel Corporation
 * 
 * Disassembling to non-symbolic legacy ASL operators
 *
 * Disassembly of SSDT-5.aml, Fri Jan 15 17:49:07 2016
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x0000080B (2059)
 *     Revision         0x01
 *     Checksum         0x34
 *     OEM ID           "AMITCG"
 *     OEM Table ID     "_SynTCG_"
 *     OEM Revision     0x00000001 (1)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20120913 (538052883)
 */
DefinitionBlock ("SSDT-5.aml", "SSDT", 1, "AMITCG", "_SynTCG_", 0x00000001)
{
    Scope (\_SB)
    {
        Device (TPM)
        {
            Name (TMF1, Zero)
            Name (TMF2, Zero)
            Name (TPMS, 0xFED40040)
            Name (SYNI, 0xB2)
            Name (SYNN, 0x35)
            Name (TRST, 0x02)
            Name (W8PI, One)
            Method (_HID, 0, NotSerialized)  // _HID: Hardware ID
            {
                Return ("MSFT0101")
            }

            Name (_STR, Unicode ("TPM 2.0 Device"))  // _STR: Description String
            Name (_UID, One)  // _UID: Unique ID
            Name (_CRS, ResourceTemplate ()  // _CRS: Current Resource Settings
            {
                DWordMemory (ResourceConsumer, PosDecode, MinFixed, MaxFixed, NonCacheable, ReadWrite,
                    0x00000000,         // Granularity
                    0xFED40000,         // Range Minimum
                    0xFED44FFF,         // Range Maximum
                    0x00000000,         // Translation Offset
                    0x00005000,         // Length
                    ,, , AddressRangeMemory, TypeStatic)
            })
            Method (_STA, 0, NotSerialized)  // _STA: Status
            {
                Return (0x0F)
            }

            OperationRegion (TSMI, SystemIO, SYNI, 0x02)
            Field (TSMI, ByteAcc, NoLock, Preserve)
            {
                INQ,    8, 
                DAT,    8
            }

            Method (SVAL, 1, NotSerialized)
            {
                If (SYNI)
                {
                    Store (ToInteger (Arg0), DAT) /* \_SB_.TPM_.DAT_ */
                    Store (SYNN, INQ) /* \_SB_.TPM_.INQ_ */
                }
            }

            Method (CRYF, 3, Serialized)
            {
                Name (_T_0, Zero)  // _T_x: Emitted by ASL Compiler
                While (One)
                {
                    Store (ToInteger (Arg1), _T_0) /* \_SB_.TPM_.CRYF._T_0 */
                    If (LEqual (_T_0, Zero))
                    {
                        Return (Buffer (One)
                        {
                             0x03                                             /* . */
                        })
                    }
                    ElseIf (LEqual (_T_0, One))
                    {
                        Name (TPMV, Package (0x02)
                        {
                            One, 
                            Package (0x02)
                            {
                                One, 
                                0x20
                            }
                        })
                        Return (TPMV) /* \_SB_.TPM_.CRYF.TPMV */
                    }

                    Break
                }

                Return (Buffer (One)
                {
                     0x00                                             /* . */
                })
            }

            Method (STRT, 3, Serialized)
            {
                Name (_T_0, Zero)  // _T_x: Emitted by ASL Compiler
                OperationRegion (TPMR, SystemMemory, TPMS, 0x1000)
                Field (TPMR, AnyAcc, NoLock, Preserve)
                {
                    Offset (0x04), 
                    FERR,   32, 
                    Offset (0x0C), 
                    BEGN,   32, 
                    Offset (0x40), 
                    HCMD,   32, 
                    HSTS,   32
                }

                While (One)
                {
                    Store (ToInteger (Arg1), _T_0) /* \_SB_.TPM_.STRT._T_0 */
                    If (LEqual (_T_0, Zero))
                    {
                        Return (Buffer (One)
                        {
                             0x03                                             /* . */
                        })
                    }
                    ElseIf (LEqual (_T_0, One))
                    {
                        If (LEqual (Or (And (HSTS, 0x02), And (HSTS, One)), 
                            0x03))
                        {
                            Store (One, HCMD) /* \_SB_.TPM_.STRT.HCMD */
                        }
                        Else
                        {
                            Store (One, FERR) /* \_SB_.TPM_.STRT.FERR */
                            Store (Zero, BEGN) /* \_SB_.TPM_.STRT.BEGN */
                        }

                        Return (Zero)
                    }

                    Break
                }

                Return (One)
            }

            Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
            {
                Name (_T_2, Zero)  // _T_x: Emitted by ASL Compiler
                Name (_T_1, Zero)  // _T_x: Emitted by ASL Compiler
                Name (_T_0, Zero)  // _T_x: Emitted by ASL Compiler
                OperationRegion (PVAR, SystemMemory, 0x37EC3018, 0x1050)
                Field (PVAR, AnyAcc, NoLock, Preserve)
                {
                    P_WR,   8, 
                    P_PD,   8, 
                    P_NR,   8, 
                    PMOR,   8, 
                    P_RC,   32, 
                    P_AP,   8, 
                    Offset (0x0C), 
                    P_AX,   32, 
                    RP00,   8, 
                    RP01,   8, 
                    RP02,   8, 
                    RP03,   8, 
                    RP04,   8, 
                    RP05,   8, 
                    RP06,   8, 
                    RP07,   8, 
                    RP08,   8, 
                    RP09,   8, 
                    RP10,   8, 
                    RP11,   8, 
                    RP12,   8, 
                    RP13,   8, 
                    RP14,   8, 
                    RP15,   8, 
                    RP16,   8, 
                    RP17,   8, 
                    RP18,   8, 
                    RP19,   8, 
                    RP20,   8, 
                    RP21,   8, 
                    RP22,   8, 
                    RP23,   8, 
                    RP24,   8, 
                    RP25,   8, 
                    RP26,   8, 
                    RP27,   8, 
                    RP28,   8, 
                    RP29,   8, 
                    RP30,   8, 
                    RP31,   8, 
                    RP32,   8, 
                    PREV,   8, 
                    Offset (0x50), 
                    PSET,   8
                }

                SVAL (0xAE)
                If (LEqual (Arg0, ToUUID ("3dddfaa6-361b-4eb4-a424-8d10089d1653") /* Physical Presence Interface */))
                {
                    SVAL (0xAF)
                    While (One)
                    {
                        Store (ToInteger (Arg2), _T_0) /* \_SB_.TPM_._DSM._T_0 */
                        If (LEqual (_T_0, Zero))
                        {
                            Return (Buffer (0x02)
                            {
                                 0xFF, 0x01                                       /* .. */
                            })
                        }
                        ElseIf (LEqual (_T_0, One))
                        {
                            SVAL (0xA1)
                            If (LEqual (W8PI, Zero))
                            {
                                Return ("1.3")
                            }

                            Return ("1.2")
                        }
                        ElseIf (LEqual (_T_0, 0x02))
                        {
                            SVAL (0xA2)
                            If (LEqual (P_AP, One))
                            {
                                Return (0x02)
                            }

                            ToInteger (DerefOf (Index (Arg3, Zero)), TMF2) /* \_SB_.TPM_.TMF2 */
                            If (LGreater (TMF2, 0x20))
                            {
                                Return (One)
                            }

                            Store (TMF2, P_PD) /* \_SB_.TPM_._DSM.P_PD */
                            Store (TMF2, P_WR) /* \_SB_.TPM_._DSM.P_WR */
                            If (LEqual (TMF2, 0x17))
                            {
                                ToInteger (DerefOf (Index (Arg3, One)), TMF2) /* \_SB_.TPM_.TMF2 */
                                Store (TMF2, P_AX) /* \_SB_.TPM_._DSM.P_AX */
                            }

                            SVAL (0xFF)
                            Return (Zero)
                        }
                        ElseIf (LEqual (_T_0, 0x03))
                        {
                            SVAL (0xA3)
                            Name (PPI1, Package (0x02)
                            {
                                Zero, 
                                Zero
                            })
                            If (LGreater (P_PD, 0x20))
                            {
                                Store (One, Index (PPI1, Zero))
                                Return (PPI1) /* \_SB_.TPM_._DSM.PPI1 */
                            }

                            Store (P_PD, Index (PPI1, One))
                            Return (PPI1) /* \_SB_.TPM_._DSM.PPI1 */
                        }
                        ElseIf (LEqual (_T_0, 0x04))
                        {
                            SVAL (0xA4)
                            Return (ToInteger (TRST))
                        }
                        ElseIf (LEqual (_T_0, 0x05))
                        {
                            SVAL (0xA5)
                            Name (PPI2, Package (0x03)
                            {
                                Zero, 
                                Zero, 
                                Zero
                            })
                            If (LEqual (P_NR, 0xFF))
                            {
                                Store (One, Index (PPI2, Zero))
                                Return (PPI2) /* \_SB_.TPM_._DSM.PPI2 */
                            }

                            Store (P_NR, Index (PPI2, One))
                            Store (P_RC, Index (PPI2, 0x02))
                            Return (PPI2) /* \_SB_.TPM_._DSM.PPI2 */
                        }
                        ElseIf (LEqual (_T_0, 0x06))
                        {
                            SVAL (0xA6)
                            Return (0x03)
                        }
                        ElseIf (LEqual (_T_0, 0x07))
                        {
                            SVAL (0xA7)
                            If (LEqual (P_AP, One))
                            {
                                Return (0x02)
                            }

                            ToInteger (DerefOf (Index (Arg3, Zero)), TMF2) /* \_SB_.TPM_.TMF2 */
                            If (LGreater (TMF2, 0x20))
                            {
                                Return (One)
                            }

                            Store (TMF2, P_PD) /* \_SB_.TPM_._DSM.P_PD */
                            Store (TMF2, P_WR) /* \_SB_.TPM_._DSM.P_WR */
                            If (LEqual (TMF2, 0x17))
                            {
                                ToInteger (DerefOf (Index (Arg3, One)), TMF2) /* \_SB_.TPM_.TMF2 */
                                Store (TMF2, P_AX) /* \_SB_.TPM_._DSM.P_AX */
                            }

                            SVAL (0xFF)
                            Return (Zero)
                        }
                        ElseIf (LEqual (_T_0, 0x08))
                        {
                            SVAL (0xA8)
                            ToInteger (DerefOf (Index (Arg3, Zero)), TMF2) /* \_SB_.TPM_.TMF2 */
                            While (One)
                            {
                                Store (TMF2, _T_1) /* \_SB_.TPM_._DSM._T_1 */
                                If (LEqual (_T_1, Zero))
                                {
                                    Return (RP00) /* \_SB_.TPM_._DSM.RP00 */
                                }
                                ElseIf (LEqual (_T_1, One))
                                {
                                    Return (RP01) /* \_SB_.TPM_._DSM.RP01 */
                                }
                                ElseIf (LEqual (_T_1, 0x02))
                                {
                                    Return (RP02) /* \_SB_.TPM_._DSM.RP02 */
                                }
                                ElseIf (LEqual (_T_1, 0x03))
                                {
                                    Return (RP03) /* \_SB_.TPM_._DSM.RP03 */
                                }
                                ElseIf (LEqual (_T_1, 0x04))
                                {
                                    Return (RP04) /* \_SB_.TPM_._DSM.RP04 */
                                }
                                ElseIf (LEqual (_T_1, 0x05))
                                {
                                    Return (RP05) /* \_SB_.TPM_._DSM.RP05 */
                                }
                                ElseIf (LEqual (_T_1, 0x06))
                                {
                                    Return (RP06) /* \_SB_.TPM_._DSM.RP06 */
                                }
                                ElseIf (LEqual (_T_1, 0x07))
                                {
                                    Return (RP07) /* \_SB_.TPM_._DSM.RP07 */
                                }
                                ElseIf (LEqual (_T_1, 0x08))
                                {
                                    Return (RP08) /* \_SB_.TPM_._DSM.RP08 */
                                }
                                ElseIf (LEqual (_T_1, 0x09))
                                {
                                    Return (RP09) /* \_SB_.TPM_._DSM.RP09 */
                                }
                                ElseIf (LEqual (_T_1, 0x0A))
                                {
                                    Return (RP10) /* \_SB_.TPM_._DSM.RP10 */
                                }
                                ElseIf (LEqual (_T_1, 0x0B))
                                {
                                    Return (RP11) /* \_SB_.TPM_._DSM.RP11 */
                                }
                                ElseIf (LEqual (_T_1, 0x0C))
                                {
                                    Return (RP12) /* \_SB_.TPM_._DSM.RP12 */
                                }
                                ElseIf (LEqual (_T_1, 0x0D))
                                {
                                    Return (RP13) /* \_SB_.TPM_._DSM.RP13 */
                                }
                                ElseIf (LEqual (_T_1, 0x0E))
                                {
                                    Return (RP14) /* \_SB_.TPM_._DSM.RP14 */
                                }
                                ElseIf (LEqual (_T_1, 0x0F))
                                {
                                    Return (RP15) /* \_SB_.TPM_._DSM.RP15 */
                                }
                                ElseIf (LEqual (_T_1, 0x10))
                                {
                                    Return (RP16) /* \_SB_.TPM_._DSM.RP16 */
                                }
                                ElseIf (LEqual (_T_1, 0x11))
                                {
                                    Return (RP17) /* \_SB_.TPM_._DSM.RP17 */
                                }
                                ElseIf (LEqual (_T_1, 0x12))
                                {
                                    Return (RP18) /* \_SB_.TPM_._DSM.RP18 */
                                }
                                ElseIf (LEqual (_T_1, 0x13))
                                {
                                    Return (RP19) /* \_SB_.TPM_._DSM.RP19 */
                                }
                                ElseIf (LEqual (_T_1, 0x14))
                                {
                                    Return (RP20) /* \_SB_.TPM_._DSM.RP20 */
                                }
                                ElseIf (LEqual (_T_1, 0x15))
                                {
                                    Return (RP21) /* \_SB_.TPM_._DSM.RP21 */
                                }
                                ElseIf (LEqual (_T_1, 0x16))
                                {
                                    Return (RP22) /* \_SB_.TPM_._DSM.RP22 */
                                }
                                ElseIf (LEqual (_T_1, 0x17))
                                {
                                    Return (RP23) /* \_SB_.TPM_._DSM.RP23 */
                                }
                                ElseIf (LEqual (_T_1, 0x18))
                                {
                                    Return (RP24) /* \_SB_.TPM_._DSM.RP24 */
                                }
                                ElseIf (LEqual (_T_1, 0x19))
                                {
                                    Return (RP25) /* \_SB_.TPM_._DSM.RP25 */
                                }
                                ElseIf (LEqual (_T_1, 0x1A))
                                {
                                    Return (RP26) /* \_SB_.TPM_._DSM.RP26 */
                                }
                                ElseIf (LEqual (_T_1, 0x1B))
                                {
                                    Return (RP27) /* \_SB_.TPM_._DSM.RP27 */
                                }
                                ElseIf (LEqual (_T_1, 0x1C))
                                {
                                    Return (RP28) /* \_SB_.TPM_._DSM.RP28 */
                                }
                                ElseIf (LEqual (_T_1, 0x1D))
                                {
                                    Return (RP29) /* \_SB_.TPM_._DSM.RP29 */
                                }
                                ElseIf (LEqual (_T_1, 0x1E))
                                {
                                    Return (RP30) /* \_SB_.TPM_._DSM.RP30 */
                                }
                                ElseIf (LEqual (_T_1, 0x1F))
                                {
                                    Return (RP31) /* \_SB_.TPM_._DSM.RP31 */
                                }
                                ElseIf (LEqual (_T_1, 0x20))
                                {
                                    Return (RP32) /* \_SB_.TPM_._DSM.RP32 */
                                }
                                Else
                                {
                                    Return (Zero)
                                }

                                Break
                            }

                            Return (Zero)
                        }
                        Else
                        {
                        }

                        Break
                    }
                }

                If (LEqual (Arg0, ToUUID ("376054ed-cc13-4675-901c-4756d7f2d45d")))
                {
                    SVAL (0xAC)
                    While (One)
                    {
                        Store (ToInteger (Arg2), _T_2) /* \_SB_.TPM_._DSM._T_2 */
                        If (LEqual (_T_2, Zero))
                        {
                            Return (Buffer (One)
                            {
                                 0x03                                             /* . */
                            })
                        }
                        ElseIf (LEqual (_T_2, One))
                        {
                            SVAL (0xB1)
                            ToInteger (DerefOf (Index (Arg3, Zero)), TMF1) /* \_SB_.TPM_.TMF1 */
                            Store (TMF1, PMOR) /* \_SB_.TPM_._DSM.PMOR */
                            SVAL (0xFF)
                            Return (Zero)
                        }
                        Else
                        {
                        }

                        Break
                    }
                }

                If (LEqual (Arg0, ToUUID ("cf8e16a5-c1e8-4e25-b712-4f54a96702c8")))
                {
                    SVAL (0xCF)
                    Return (CRYF (Arg1, Arg2, Arg3))
                }

                If (LEqual (Arg0, ToUUID ("6bbf6cab-5463-4714-b7cd-f0203c0368d4")))
                {
                    SVAL (0xDF)
                    Return (STRT (Arg1, Arg2, Arg3))
                }

                SVAL (0xEF)
                Return (Buffer (One)
                {
                     0x00                                             /* . */
                })
            }
        }
    }
}

